const proc = require('child_process')

const boltURI = process.argv[2],
  neo4jUser = process.argv[3],
  neo4jPassword = process.argv[4],
  typeDefs = process.argv[5]
cwd = __dirname

const child = proc.spawn(
  'now',
  [
    `-e`,
    `NEO4J_USER=${neo4jUser}`,
    `-e`,
    `NEO4J_PASSWORD=${neo4jPassword}`,
    `-e`,
    `NEO4J_URI=${boltURI}`,
    `-e`,
    `GRAPHQL_TYPEDEFS=${typeDefs}`,
  ],
  { cwd }
)

child.on('exit', function (code, signal) {
  console.log(
    'child process exited with ' + `code ${code} and signal ${signal}`
  )
})

child.on('error', (err) => {
  console.log(err)
})

child.stdout.on('data', (data) => {
  console.log(data.toString())
})

child.stderr.on('data', (data) => {
  console.error(data.toString())
})
