"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.handler = exports.builder = exports.desc = exports.command = void 0;

const {
  makeAugmentedSchema
} = require("neo4j-graphql-js");

const {
  ApolloServer
} = require("apollo-server");

const neo4j = require("neo4j-driver");

const command = "graphql";
exports.command = command;
const desc = "Start GraphQL service";
exports.desc = desc;
const builder = {};
exports.builder = builder;

const handler = () => {
  const typeDefs = `type Person {name: String}`;
  const schema = makeAugmentedSchema({
    typeDefs
  });
  const driver = neo4j.driver("bolt://localhost:7687", neo4j.auth.basic("neo4j", "letmin"));
  const server = new ApolloServer({
    schema,
    context: {
      driver
    }
  });
  server.listen(3003, "0.0.0.0").then(({
    url
  }) => {
    console.log(`GraphQL API ready at ${url}`);
  });
};

exports.handler = handler;